<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="hu"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>SpriteStore.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Spaceinvaders sprites</a> &gt; <a href="index.source.html" class="el_package">default</a> &gt; <span class="el_source">SpriteStore.java</span></div><h1>SpriteStore.java</h1><pre class="source lang-java linenums">

import java.awt.GraphicsConfiguration;
import java.awt.GraphicsEnvironment;
import java.awt.Image;
import java.awt.Transparency;
import java.awt.image.BufferedImage;
import java.io.IOException;
import java.net.URL;
import java.util.HashMap;

import javax.imageio.ImageIO;

/**
 * A resource manager for sprites in the game. Its often quite important
 * how and where you get your game resources from. In most cases
 * it makes sense to have a central resource loader that goes away, gets
 * your resources and caches them for future use.
 * &lt;p&gt;
 * [singleton]
 * &lt;p&gt;
 * @author Kevin Glass
 */
<span class="fc" id="L24">public class SpriteStore {</span>
	/** The single instance of this class */
<span class="fc" id="L26">	private static SpriteStore single = new SpriteStore();</span>
	
	/**
	 * Get the single instance of this class 
	 * 
	 * @return The single instance of this class
	 */
	public static SpriteStore get() {
<span class="fc" id="L34">		return single;</span>
	}
	
	/** The cached sprite map, from reference to sprite instance */
<span class="fc" id="L38">	private HashMap sprites = new HashMap();</span>
	
	/**
	 * Retrieve a sprite from the store
	 * 
	 * @param ref The reference to the image to use for the sprite
	 * @return A sprite instance containing an accelerate image of the request reference
	 */
	public Sprite getSprite(String ref) {
		// if we've already got the sprite in the cache
		// then just return the existing version
<span class="pc bpc" id="L49" title="1 of 2 branches missed.">		if (sprites.get(ref) != null) {</span>
<span class="nc" id="L50">			return (Sprite) sprites.get(ref);</span>
		}
		
		// otherwise, go away and grab the sprite from the resource
		// loader
<span class="fc" id="L55">		BufferedImage sourceImage = null;</span>
		
		try {
			// The ClassLoader.getResource() ensures we get the sprite
			// from the appropriate place, this helps with deploying the game
			// with things like webstart. You could equally do a file look
			// up here.
<span class="fc" id="L62">			URL url = this.getClass().getClassLoader().getResource(ref);</span>
			
<span class="pc bpc" id="L64" title="1 of 2 branches missed.">			if (url == null) {</span>
<span class="nc" id="L65">				fail(&quot;Can't find ref: &quot;+ref);</span>
			}
			
			// use ImageIO to read the image in
<span class="fc" id="L69">			sourceImage = ImageIO.read(url);</span>
<span class="nc" id="L70">		} catch (IOException e) {</span>
<span class="nc" id="L71">			fail(&quot;Failed to load: &quot;+ref);</span>
<span class="fc" id="L72">		}</span>
		
		// create an accelerated image of the right size to store our sprite in
<span class="fc" id="L75">		GraphicsConfiguration gc = GraphicsEnvironment.getLocalGraphicsEnvironment().getDefaultScreenDevice().getDefaultConfiguration();</span>
<span class="fc" id="L76">		Image image = gc.createCompatibleImage(sourceImage.getWidth(),sourceImage.getHeight(),Transparency.BITMASK);</span>
		
		// draw our source image into the accelerated image
<span class="fc" id="L79">		image.getGraphics().drawImage(sourceImage,0,0,null);</span>
		
		// create a sprite, add it the cache then return it
<span class="fc" id="L82">		Sprite sprite = new Sprite(image);</span>
<span class="fc" id="L83">		sprites.put(ref,sprite);</span>
		
<span class="fc" id="L85">		return sprite;</span>
	}
	
	/**
	 * Utility method to handle resource loading failure
	 * 
	 * @param message The message to display on failure
	 */
	private void fail(String message) {
		// we're pretty dramatic here, if a resource isn't available
		// we dump the message and exit the game
<span class="nc" id="L96">		System.err.println(message);</span>
<span class="nc" id="L97">		System.exit(0);</span>
<span class="nc" id="L98">	}</span>
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.jacoco.org/jacoco">JaCoCo</a> 0.8.2.201808211720</span></div></body></html>